Bug 154471 - Analogue of META-INF/exists/* to cover non-JAR installed files in JNLP mode
Analogue of META-INF/exists/* to cover non-JAR installed files in JNLP mode
Status: RESOLVED FIXED
Product: apisupport
Classification: Unclassified
Component: Harness
6.x
All All
: P3 (vote)
: 6.x
Assigned To: apireviews
issues@apisupport
: API, API_REVIEW_FAST
Depends on:
Blocks: 90498 154108
  Show dependency treegraph
 
Reported: 2008-12-03 15:16 UTC by Jesse Glick
Modified: 2009-02-19 20:18 UTC (History)
2 users (show)

See Also:
Issue Type: ENHANCEMENT
:


Attachments
Sample application taking advantage of new facility (13.86 KB, application/x-compressed)
2008-12-03 17:35 UTC, Jesse Glick
Details
Proposed patch (11.03 KB, patch)
2008-12-03 17:36 UTC, Jesse Glick
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jesse Glick 2008-12-03 15:16:14 UTC
After issue #90498, if you specify jnlp.indirect.jars for some random JAR files not in your module's classpath, they
will be added to the JNLP classpath with an extra entry so that InstalledFileLocator will be able to find them at
runtime. Very helpful for letting modules smoothly switch to JNLP operation.

This does not help for other kinds of files packed in the NBM. There should be a separate but similar property such as
jnlp.indirect.files, a list of relative paths to files in the NBM fileset which would otherwise need to be listed in
jnlp.verify.excludes. MakeJNLP should collect all of these into one ZIP file added to the JNLP classpath. Suggested
format: for each entry in the list such as maven2/settings.xml, pack into META-INF/files/maven2/settings.xml.

Then jnlplauncher.InstalledFileLocatorImpl could simply look for the corresponding resource in its CP. If found, extract
to a temporary file somewhere - File.createTempFile and deleteOnExit, or could perhaps use javax.jnlp.* methods to use
local storage. Then return that temp file.
Comment 1 Jesse Glick 2008-12-03 15:20:59 UTC
Would be helpful for issue #154108, for example.
Comment 2 Jesse Glick 2008-12-03 17:35:12 UTC
Created attachment 74495 [details]
Sample application taking advantage of new facility
Comment 3 Jesse Glick 2008-12-03 17:36:47 UTC
Created attachment 74496 [details]
Proposed patch
Comment 4 Jesse Glick 2008-12-03 17:37:22 UTC
Please review.
Comment 5 Lukas Hasik 2008-12-04 08:48:58 UTC
LH1 - please, do not push enhancements in "stabilization" phase of Milestone 1 (http://wiki.netbeans.org/NetBeans70).
Postpone the changes after M1 clone will be created. Thank you.
Comment 6 Jesse Glick 2008-12-04 15:35:26 UTC
How silly. If you really wanted to stabilize, you should have branched it already.
Comment 7 Quality Engineering 2008-12-05 06:26:22 UTC
Integrated into 'main-golden', will be available in build *200812050201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/ce4121ee3e22
User: Milos Kleint <mkleint@netbeans.org>
Log: #154108 exclude java cluster as maven.grammar has zillions of maven plugin xml files as external resources, need #154471 fixed.
Comment 8 Jesse Glick 2008-12-17 17:08:06 UTC
core-main #88db1a110934

Miloš you may want to use this in Maven modules (issue #154108).
Comment 9 Quality Engineering 2008-12-18 06:39:35 UTC
Integrated into 'main-golden', will be available in build *200812180201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/88db1a110934
User: Jesse Glick <jglick@netbeans.org>
Log: #154471: add jnlp.indirect.files property to make InstalledFileLocator more useful in JNLP mode.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo